import { postHashtags, retrieveHashtagsFromGweet } from "@/components/trends";

export const postGweet = async ({
  content,
  userId,
  replyToUserId,
  replyToGweetId,
}: {
  content: string;
  userId: string;
  replyToUserId?: string | null;
  replyToGweetId?: string | null;
}) => {
  const gweet = {
    content,
    userId,
    // if no replyToUserId, don't send it
    ...(replyToUserId && { replyToUserId }),
    // if no replyToGweetId, don't send it
    ...(replyToGweetId && { replyToGweetId }),
  };

  try {
    const data = await fetch('/api/gweets', {
      method: 'POST',
      body: JSON.stringify(gweet)
    }).then((result) => result.json())

    const hashtags = retrieveHashtagsFromGweet(content);
    if (hashtags) await postHashtags(hashtags);

    return data;
  } catch (error: any) {
    return error.response.data;
  }
};